
; *****************************************************************************
;
;                        Zmek pro diskov jednotky
;
; *****************************************************************************

code     SEGMENT
         ASSUME    cs:code,ds:code
         ORG       100h

start:   jmp       Instal                   ; instalace programu

Identif  db        'DISKLOCK V1.10'         ; identifikan text
Identif0 label     byte                     ; konec identifikanho textu

RezSeg   dw        0                        ; adresa rezidentn instalace

; -----------------------------------------------------------------------------

Flop     db        1                        ; Floppy: 0 = neblokovano
                                            ;         1 = zapis do BOOT
                                            ;         2 = zapis
                                            ;         3 = pristup na disk

Winch    db        1                        ; Winchst:0 = neblokovano
                                            ;         1 = zapis do BOOT
                                            ;         2 = zapis
                                            ;         3 = pristup na disk

Klav     db        1                        ; pznak zapnut klvesnice

Zvuk     db        1                        ; pznak zapnut zvuku

; -----------------------------------------------------------------------------

Old09    dd        0                        ; pvodn adresa INT 09h
Old13    dd        0                        ; pvodn adresa INT 13h
Old40    dd        0                        ; pvodn adresa INT 40h

; -----------------------------------------------------------------------------

Int09    PROC      FAR

         push      bx
         push      ds
         mov       bx,40h
         mov       ds,bx
         mov       bx,ds:[1ch]

         pushf
         call      dword ptr cs:[old09]

         cmp       byte ptr cs:[Klav],1     ; je povoleno ovldn klvesnic ?
         jne       Int093                   ; nen povoleno ovldn klvesnic

         cmp       bx,ds:[1ch]              ; byla njak klvesa ?
         je        Int093                   ; nebyla dn klvesa

                                          ;* test pesmyka Shft-Alt
         test      byte ptr ds:[17h],3      ; je pesmyka SHIFT ?
         jz        Int093                   ; nen pesmyka SHIFT
         test      byte ptr ds:[17h],8      ; je pesmyka ALT ?
         jz        Int093                   ; nen pesmyka ALT

                                          ;* test klves Alt-F1 a Alt-F8
         cmp       byte ptr ds:[bx+1],68h   ; je klvesa Alt-F1 ?
         jb        Int093                   ; nen platn klvesa
         cmp       byte ptr ds:[bx+1],6fh   ; je klvesa Alt-F8 ?
         ja        Int093                   ; nen platn klvesa
         mov       ds:[1ch],bx              ; zruen klvesy z bufferu

                                          ;* nastaven kdu klvesy
         mov       bx,ds:[bx]               ; kd klvesy
         sub       bh,68h                   ; korekce na slo 0 a 7
         cmp       bh,4                     ; nastaven pro pevn disk ?
         jae       Int092                   ; nastaven pro pevn disk
         call      Beep                     ; zvukov signalizace odezvy
         mov       cs:[Flop],bh             ; kd pro diskety
         jmp       short Int093
Int092:  sub       bh,4                     ; nastaven pro pevn disk
         call      Beep                     ; zvukov signalizace odezvy
         mov       cs:[Winch],bh            ; kd pro pevn disk

Int093:  pop       ds
         pop       bx
         iret

Int09    ENDP

; -----------------------------------------------------------------------------

Beep     PROC      NEAR

         cmp       byte ptr cs:[Zvuk],1
         jne       Beep2

         push      ax
         push      bx
         push      cx

         mov       cx,35000

         mov       al,0b6h
         out       [43h],al
         mov       al,6
         sub       al,bh
         out       [42h],al
         out       [42h],al

         in        al,[61h]
         push      ax
         or        al,3
         out       [61h],al

         loop      $

         pop       ax
         out       [61h],al

         pop       cx
         pop       bx
         pop       ax

Beep2:   RET

Beep     ENDP

; -----------------------------------------------------------------------------

Int13    PROC      FAR

         pushf

         cmp       ah,8
         jne       Int133
         cmp       dl,26h                   ; kontroln slo disku
         jne       Int133

         push      cx
         push      si
         push      di
         push      es

         push      cs
         pop       es
         cld
         mov       cx,offset(Identif0-Identif) ; dlka textu
         mov       si,offset Identif        ; identifikan text
         mov       di,si
         repe      cmpsb                    ; porovnn text

         pop       es
         pop       di
         pop       si
         pop       cx
         jne       Int133                   ; text nesouhlas
         mov       ds:[RezSeg],cs           ; rezidentn segment

Int133:  popf

         call      Blok                     ; test blokovn funkce
         jmp       dword ptr cs:[Old13]

Int13    ENDP

; -----------------------------------------------------------------------------

Int40    PROC      FAR

         call      Blok
         jmp       dword ptr cs:[Old40]

Int40    ENDP

; -----------------------------------------------------------------------------

                                          ;* test blokovn funkce
                                          ;* - v zsobnku nesm bt nic jinho
                                          ;*   ne nvratov adresa NEAR !

Blok     PROC      NEAR

                                            ; SS:[BP+8] = F
                                            ; SS:[BP+6] = CS
                                            ; SS:[BP+4] = IP
                                            ; SS:[BP+2] = IP

         push      bp                       ; schova BP SS:[BP+0]
         mov       bp,sp                    ; ukazatel dat v zsobnku
         push      ax                       ; schova AX SS:[BP-2]

                                          ;* povolen funkce
         cmp       ah,1                     ; je reset diskovho systmu ?
         jbe       Blok7                    ; reset disk nebo dotaz na stav
         cmp       ah,8                     ; je poskytnut parametr ?
         je        Blok7                    ; poskytnut parametr - OK
         cmp       ah,9                     ; inic. tabulky pevnho disku ?
         je        Blok7                    ; inic. tabulky pevnho disku - OK
         cmp       ah,0dh                   ; reset disku ?
         jae       Blok7                    ; sluba se nekontroluje

                                          ;* pznak stavu disku
         mov       al,cs:[Flop]             ; pznaky FLOPPY
         or        dl,dl                    ; je pstup na FLOPPY ?
         jns       Blok1                    ; je pstup na FLOPPY
         mov       al,cs:[Winch]            ; pznaky pevnho disku

                                          ;* disk nen blokovn
Blok1:   or        al,al                    ; je njak blokovn ?
         jz        Blok7                    ; disk nen blokovn - nvrat

                                          ;* zakzn zpis do BOOT sektoru
         dec       al                       ; je zkaz zpisu do BOOT ?
         jnz       Blok2                    ; nen zkaz zpisu do BOOT

         cmp       ah,3                     ; je zpis sektor na disk ?
         je        Blok11                   ; je zpis na disk
         cmp       ah,0bh                   ; je dlouh zpis ?
         je        Blok11                   ; je dlouh zpis
         cmp       ah,5                     ; formtovn stopy ?
         je        Blok13                   ; formtovn
         cmp       ah,6
         je        Blok13                   ; formtovn s oznaenm
         cmp       ah,7
         jne       Blok7                    ; nen formtovn disku
Blok13:  jmp       short Blok12             ; nekontroluje se sektor

                                          ;* kontrola sektoru pi zpisu BOOT
Blok11:  mov       al,cl                    ; slo sektoru
         and       al,3fh                   ; slo sektoru
         dec       al
         jnz       Blok7                    ; nen BOOT sektor - OK

                                          ;* kontrola vlce a hlavy BOOT
Blok12:  or        ch,ch                    ; ni slovo vlce = 0 ?
         jnz       Blok7                    ; nen zpis na stopu 0
         or        dh,dh                    ; hlava = 0 ?
         jnz       Blok7                    ; nen zpis na stopu 0
         mov       al,cl                    ; vy st sla vlce
         and       al,0c0h                  ; nejvy 2 bity sla vlce
         jnz       Blok7                    ; nen stopa 0
         jmp       short Blok31             ; je zpis do BOOT sektoru - chyba

                                          ;* pstup na disk blokovn
Blok4:   mov       ah,80h                   ; kd chyby - disk nepipraven
         jmp       short Blok32             ; nvrat s chybou


Blok7:   pop       ax
         pop       bp
         ret

                                          ;* zakzn zpis na disk
Blok2:   dec       al                       ; je zkaz zpisu na disk ?
         jnz       Blok4                    ; nen zkaz zpisu na disk
         cmp       ah,3                     ; je funkce zpisu na disk ?
         je        Blok31                   ; je funkce zpisu na disk - zkaz
         cmp       ah,5                     ; je funkce formtovn ?
         jb        Blok7                    ; nen formtovn - OK
         cmp       ah,7                     ; je formtovn ?
         jbe       Blok31                   ; je formtovn - zkaz
         cmp       ah,0bh                   ; je dlouh zpis
         jne       Blok7                    ; nen dlouh zpis - OK

                                          ;* chyba - ochrana proti zpisu
Blok31:  mov       ah,3                     ; kd chyby - ochrana proti zpisu

                                          ;* chyba - pstup nepovolen
Blok32:  xor       al,al                    ; dn sektor
         mov       word ptr ss:[bp-2],ax    ; nvratov kd chyby

         or        word ptr ss:[bp+8],201h  ; pznak peruen a chyby CY

                                          ;* uloen kdu chyby do pamti BIOS
         push      ds
         push      bx
         xor       bx,bx
         mov       ds,bx                    ; DS <- BX
         or        dl,dl
         js        Blok37                   ; je pevn disk
         mov       ds:[441h],ah             ; stav pro disketov jednotky
         jmp       short Blok38
Blok37:  mov       ds:[474h],ah             ; stav pro pevn disk
Blok38:  pop       bx
         pop       ds

                                          ;* zvukov signalizace
         cmp       byte ptr cs:[Zvuk],1
         jne       Blok35

         push      cx
         mov       cx,18000
         mov       al,0b6h
         out       [43h],al
         mov       al,2
         out       [42h],al
         out       [42h],al
         in        al,[61h]
         mov       ah,al
         or        al,3
         out       [61h],al
         loop      $
         mov       al,ah
         out       [61h],al
         pop       cx
Blok35:
         pop       ax                       ; nvrat AX
         pop       bp                       ; nvrat BP
         add       sp,2                     ; zruen nvratov adresy
         iret                               ; nvrat z obsluhy


Blok     ENDP

; -----------------------------------------------------------------------------
;        Instalace programu
; -----------------------------------------------------------------------------

                                          ;* zobrazen vodnho textu
Instal:  mov       dx,offset uvtxt          ; vodn text
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

                                          ;* nalezen rezidentn instalace
         mov       ds:[RezSeg],ds           ; segment rezidentn sti
         mov       dl,26h                   ; kontroln slo disku
         mov       ah,8                     ; funkce poskytnut parametr
         int       13h                      ; test stavu instalace
         mov       es,ds:[RezSeg]           ; segment s rezidentn st

                                          ;* pprava pro rozbor zadn
         mov       si,81h                   ; zatek pkaz. dku
         xor       bx,bx                    ; BH <- 0
         mov       bl,ds:[80h]              ; poet znak textu
         mov       byte ptr ds:[si+bx],0    ; oznaen konce textu

                                          ;* naten prvnho znaku
Instal1: call      InpCh                    ; vstup znaku z parametr
         jc        Instal4                  ; konec textu - instalace
         je        Instal1                  ; ignorovn mezer

                                          ;* parametr "Kn" - nastav. klvesnice
         cmp       al,"K"                   ; je parametr "K" ?
         jne       Instal13                 ; nen parametr "K"
         call      InpCh                    ; naten znaku parametru
         jbe       Instal3                  ; chyba zadn parametru
         sub       al,"0"                   ; korekce na slo
         jc        Instal3                  ; chyba zadn
         cmp       al,1
         ja        Instal3                  ; chyba zadn
         mov       es:[Klav],al             ; pznak klvesnice
         jmp       short Instal1            ; dekdovn dalho parametru


                                          ;* parametr "Sn" - zvuk. signal.
Instal13:cmp       al,"S"                   ; je parametr "S" ?
         jne       Instal14                 ; nen parametr "S"
         call      InpCh                    ; naten znaku parametru
         jbe       Instal3                  ; chyba zadn parametru
         sub       al,"0"                   ; korekce na slo
         jc        Instal3                  ; chyba zadn
         cmp       al,1
         ja        Instal3                  ; chyba zadn
         mov       es:[Zvuk],al             ; pznak signalizac
         jmp       short Instal1            ; dekdovn dalho parametru

                                          ;* volba "X" - odinstalovani programu
Instal14:cmp       al,"X"                   ; je parametr "X" ?
         jne       Instal17
         jmp       Odinstal                 ; odinstalovani programu z pameti

                                          ;* slo 1 a 8 (pepna)
Instal17:sub       al,"1"                   ; korekce na slo
         jc        Instal3                  ; chyba zadn
         cmp       al,8
         jae       Instal3                  ; chyba zadn
         cmp       al,4
         jae       Instal15                 ; je pevn disk
         mov       es:[Flop],al             ; nastaven disket. mechanik
         jmp       short Instal1            ; dal parametr
Instal15:sub       al,4
         mov       es:[Winch],al            ; pevn disk
         jmp       short Instal1            ; dal parametr

                                          ;* je zobrazen npovdy
Instal3: mov       dx,offset HelpTxt        ; text npovdy
         mov       ah,9
         int       21h                      ; zobrazen npovdy
Instal5: int       20h                      ; program se neinstaluje


                                          ;* hlen o stavu instalace
Instal4: mov       al,es:[Flop]             ; pznak pro FLOPPY
         add       byte ptr ds:[HelpT1],al  ; slo pro FLOPPY
         mov       al,es:[Winch]            ; pznak pro pevn disk
         add       byte ptr ds:[HelpT1+2],al; slo pro FLOPPY
         mov       al,es:[Klav]             ; pznak aktivity klvesnice
         add       byte ptr ds:[HelpT1+5],al; aktivita klvesnice
         mov       al,es:[Zvuk]             ; prznak aktivity zvuku
         add       byte ptr ds:[HelpT1+8],al; aktivita zvukov signalizace
         mov       dx,offset HelpTxt1       ; text npovdy
         mov       ah,9
         int       21h                      ; zobrazen npovdy

         mov       ax,ds
         mov       bx,es
         cmp       ax,bx                    ; je to prvn instalace ?
         jne       Instal5                  ; nen to prvn instalace - konec

                                          ;* instalace obsluhy INT 09h
         mov       ax,3509h
         int       21h
         mov       word ptr ds:[Old09],bx
         mov       word ptr ds:[Old09+2],es
         mov       dx,offset Int09
         mov       ax,2509h
         int       21h

                                          ;* instalace obsluhy INT 13h
         mov       ax,3513h
         int       21h
         mov       word ptr ds:[Old13],bx
         mov       word ptr ds:[Old13+2],es
         mov       dx,offset Int13
         mov       ax,2513h
         int       21h

                                          ;* instalace obsluhy INT 40h
         mov       ax,3540h
         int       21h
         mov       word ptr ds:[Old40],bx
         mov       word ptr ds:[Old40+2],es
         mov       dx,offset Int40
         mov       ax,2540h
         int       21h

         mov       ah,49h
         mov       es,ds:[2ch]
         int       21h                      ; uvolnn bloku prosted

         mov       dx,offset Instal
         int       27h

; -----------------------------------------------------------------------------

                                          ;* odinstalovani programu z pameti
Odinstal:
                                          ;* kontrola, zda jsou vektory OK
         mov       dx,es                    ; schova ES
         mov       ax,cs
         cmp       ax,dx
         je        OdInst7                  ; nebyl nainstalovn

         push      es
         mov       ax,3509h
         int       21h                      ; poskytnut adresy INT 09h
         mov       cx,es                    ; segment adresy INT 09h
         pop       es
         cmp       cx,dx                    ; souhlas segment adresy ?
         jne       Odinst8                  ; adresa nesouhlas

         push      es
         mov       ax,3513h
         int       21h                      ; poskytnut adresy INT 13h
         mov       cx,es                    ; segment adresy INT 13h
         pop       es
         cmp       cx,dx                    ; souhlas segment adresy ?
         jne       Odinst8                  ; adresa nesouhlas

         push      es
         mov       ax,3540h
         int       21h                      ; poskytnut adresy INT 40h
         mov       cx,es                    ; segment adresy INT 40h
         pop       es
         cmp       cx,dx                    ; souhlas segment adresy ?
         jne       Odinst8                  ; adresa nesouhlas

                                          ;* program lze odinstalovat
         lds       dx,es:[Old09]            ; pvodn adresa INT 09h
         mov       ax,2509h
         int       21h                      ; nvrat adresy INT 09h
         lds       dx,es:[Old13]            ; pvodn adresa INT 13h
         mov       ax,2513h
         int       21h                      ; nvrat adresy INT 13h
         lds       dx,es:[Old40]            ; pvodn adresa INT 40h
         mov       ax,2540h
         int       21h                      ; nvrat adresy INT 40h
         mov       ah,49h
         int       21h                      ; uvolnn alokanho bloku pamti
         mov       dx,offset UvolTxt
         jmp       short Odinst9            ; hlen o odinstalovn

                                          ;* program nebyl nainstalovn
OdInst7: mov       dx,offset Uvol1Txt
         jmp       short OdInst9

                                          ;* program nelze odinstalovat
Odinst8: mov       dx,offset Uvol0Txt
Odinst9: push      cs
         pop       ds
         mov       ah,9
         int       21h
         int       20h

; -----------------------------------------------------------------------------

InpCh    PROC      NEAR

         mov       al,ds:[si]               ; znak z textu tadn

                                          ;* korekce na velk psmena
         cmp       al,"a"
         jb        InpCh1                   ; nen mal psmeno
         cmp       al,"z"
         ja        InpCh1                   ; nen mal psmeno
         sub       al,32                    ; korekce na velk psmeno

                                          ;* nhrada tabeltoru mezerou
InpCh1:  cmp       al,9
         jne       InpCh2
         mov       al," "

                                          ;* kontrola, zda je konec textu
InpCh2:  cmp       al," "
         jb        InpCh3
         inc       si                       ; zven ukazatele textu
         cmp       al," "

InpCh3:  ret

InpCh    ENDP

; -----------------------------------------------------------------------------

UvTxt    db        'DISKLOCK V 1.10 - uzamceni disku;  (c) Miroslav Nemecek',13,10
         db        '$'

HelpTxt  db        '=======================================================',13,10
         db        ' diskety  pevny disk Ŀ',13,10
         db        ' Shift-Alt-F1  Shift-Alt-F5  plny pristup na disk  ',13,10
         db        ' Shift-Alt-F2  Shift-Alt-F6  zakaz modifikace BOOT ',13,10
         db        ' Shift-Alt-F3  Shift-Alt-F7  zakaz zapisu na disk  ',13,10
         db        ' Shift-Alt-F4  Shift-Alt-F8  disk nepristupny      ',13,10
         db        '',13,10
         db        'Zadejte:   1 az 8 = jako klavesy Shift-Alt-F1 ... F8',13,10
         db        '           K0, K1 = ovladani z klavesnice VYP, ZAP',13,10
         db        '           S0, S1 = zvukova signalizace VYP, ZAP',13,10
         db        '           X      = odinstalovani programu DISKLOCK',13,10
         db        '$'

HelpTxt1 db        'Soucasne nastaveni: DISKLOCK '
HelpT1   db        '1 5 K0 S0   (? = napoveda)',13,10
         db        '$'

UvolTxt  db        'DISKLOCK byl odinstalovan z pameti.',13,10,'$'
Uvol0Txt db        'DISKLOCK nelze odinstalovat - odinstalujte nejdrive',13,10
         db        '         programy nainstalovane po nem.',13,10,'$'
Uvol1Txt db        'DISKLOCK nebyl dosud nainstalovan !',13,10,'$'

code     ends
         end       start
